﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Network_Local As String
	Dim strSplit() As String
	Dim strSplit2() As String
	Dim strSSID As String
	Dim strBSSID As String
	Dim strSECURITY As String
	Dim strLEVEL As String
	Dim strFREQUENCY As String
	Dim list1 As List
	Dim listConfigured As List
	Dim sSignal As String
	'	Dim listState As List
	Dim sState As String
	Dim sRank As String
	Dim Ip As String
	Dim WiFiConnect1 As WiFiConnect
	Dim Mac_Address As String
	Private ResultsBkp  As List
	Dim Ref_Network As String
	Private bconv As ByteConverter
	Dim bb As B4XBytesBuilder
	Dim tplink_entete As String="PowerHeader1.txt"
	Dim Network As String
	'Private Password As String
	'Private login As String
	'Private Str_Util As StringFunctions
	Dim sending_data As Boolean=False
	Private device As String
	
	Dim SSID_name_tplink As String
	
	
	
End Sub

Sub Service_Create
	ResultsBkp.Initialize
	ResultsBkp.Clear
	WiFiConnect1.Initialize
	bb.Initialize
	device="Recherche en cours..."
End Sub

Sub load_data(file_name As String, command As String) As ResumableSub
	
	If File.Exists(File.DirDefaultExternal,file_name)=False Then
		File.Copy(File.DirAssets,file_name,File.DirDefaultExternal,file_name)
	End If
	
	Dim reader As InputStream = File.OpenInput(File.DirDefaultExternal, file_name)
	Dim data_array(reader.BytesAvailable) As Byte
	bb.Clear
	
	Try
		reader.ReadBytes(data_array,0,reader.BytesAvailable)
		bconv.LittleEndian=False
		encode_data(data_array, command) 'Encodage des données à transmettre
		Dim data_array(bb.Length) As Byte
		data_array=bb.SubArray(0)
		NewData(data_array) 'Affichage des données décryptée pour le débug
		CallSub2(TPL_Echange, "SendData", data_array) 'Envoi des données
		'NewData(data_array)
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
	
	
	
End Sub

Sub encode_data(data() As Byte,command As String)
	Dim key As Int=144  '144 'Dernier octet encodé de la trame. ref pour encodage des octets suivants (160) 218
	
	Dim data_next() As Byte
	Dim data_byte_encrypted As Int
	
	
	' Liste des commandes pré-formatée avant cryptage
	
	'Dim network1 As String=  Chr(34) & "password" & Chr(34) & Chr(58) & Chr(34) & Password & Chr(34) & Chr(44) & Chr(34) & "ssid" & Chr(34) & Chr(58) & Chr(34) & "HomeyHome" & Chr(34) & Chr(125) & Chr(125) & Chr(125)
'	Dim network As String= Chr(34) & "netif" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_stainfo" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "key_type" & Chr(34) & Chr(58) & "3" & Chr(44) & Chr(34) & "password" & Chr(34) & Chr(58) & Chr(34) & Password & Chr(34) & Chr(44) & Chr(34) & "ssid" & Chr(34) & Chr(58) & Chr(34) & login & Chr(34) & Chr(125) & Chr(125) & Chr(125)
'	Dim scan_network As String= Chr(34) & "netif" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_scaninfo" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "refresh" & Chr(34) & Chr(58) & "1" & Chr(125) & Chr(125) & Chr(125)
'	Dim get_info As String=  Chr(34) & "system" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_sysinfo" & Chr(34) & Chr(58) & Chr(123) & Chr(125)  & Chr(125) & Chr(125)   '{"system":{"get_sysinfo":Null}} '& Chr(123)  & Chr(125)
'	Dim set_off As String= Chr(34) & "system" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_relay_state" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "state"  & Chr(34) & Chr(58) & "1" & Chr(125) & Chr(125) & Chr(125)  '{"system":{"get_sysinfo":Null}}
'	Dim other As String= Chr(34) & "system" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_led_off" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "off"  & Chr(34) & Chr(58) & "0" & Chr(125) & Chr(125) & Chr(125)  '{"system":{"get_sysinfo":Null}}
'	Dim conso_live As String= Chr(34) & "emeter" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_realtime" & Chr(34) & Chr(58) & Chr(123)  & Chr(125) & Chr(125) & Chr(125)  '{"system":{"get_sysinfo":Null}}
'	Dim get_time As String= Chr(34) & "time" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_time" & Chr(34) & Chr(58) & Chr(123)  & Chr(125) & Chr(125) & Chr(125)  '{"system":{"get_sysinfo":Null}}

	data_next= bconv.StringToBytes(command,"ASCII")
	
	'header
	Dim entete_format(4) As Byte
'	
	entete_format(3)=data_next.Length + data.Length 'Définition du nombre d'octet à envoyer
	
	bb.Append(entete_format)
'	
	For Each data2 As Byte In data
		Dim data3(1) As Byte
		data3(0)=data2
		bb.Append(data3)
		'Log(bconv.HexFromBytes(data3))
	Next
	
	
	
	For Each data1 As Byte In data_next
		data_byte_encrypted=Bit.Xor(data1,key) 'Mask FF pour être en LittleEndian
		Dim byte1(1) As Byte
		byte1(0)=data_byte_encrypted
		key=byte1(0)
		bb.Append(byte1)
		'Log(bconv.HexFromBytes(byte1))
	Next
	
End Sub

Sub NewData (data() As Byte)
	
	Dim key As Int=171
	
	Dim data_byte_decrypted As Int
	Dim pos As Int=0
		
	
	Dim message As String=""
	For pos = 4 To data.Length-1
			
		data_byte_decrypted=Bit.Xor(Bit.And(data(pos), 0xFF),key) 'Mask FF pour être en LittleEndian
		Dim byte1(1) As Byte
		byte1(0)=data_byte_decrypted
		
		Dim carac As String = bconv.StringFromBytes(byte1,"ASCII")
		key=data(pos)
		message=message & carac
		bb.Append(byte1)
		
	Next
	Log(message)
	
End Sub
Sub Service_Start (StartingIntent As Intent)
	'StartService(TPL_Echange)
	'scan
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Sub scan
	
	Ref_Network=""
	Try
		device="Recherche en cours..."
		CallSub2(Main.IU_Setup_Power_connected,"refresh",device)
		'CallSub2(Main,"CallBack_IU",device)
		list1.Initialize
		list1.Clear
		listConfigured.Initialize
		listConfigured.Clear
		'	listState.Initialize
		
		If WiFiConnect1.getWifiState <> WiFiConnect1.WIFI_STATE_ENABLED Then
			WiFiConnect1.setWifiEnabled(True)
		End If
		
		WiFiConnect1.startScan
		
		list1 = WiFiConnect1.getScanResults
		
		listConfigured = WiFiConnect1.getConfiguredNetworks
		
		'ListView1.Clear
		ResultsBkp.Clear
		'	listState.Clear
		
		For i = 0 To list1.Size -1
			'		Msgbox(list1.Get(i), "")
			strSSID = ""
			strSECURITY = ""
			
			strSplit = Regex.Split(",", list1.Get(i))
			For j = 0 To strSplit.Length -1
				strSplit2 = Regex.Split(": ", strSplit(j))
				If strSplit2.Length = 2 Then
					If strSplit2(0).Contains("BSSID") Then
						strBSSID = strSplit2(1).Trim
					Else If strSplit2(0).Contains("SSID") Then
						strSSID = strSplit2(1).Trim
					Else If strSplit2(0).Contains("capabilities") Then
						strSECURITY = strSplit2(1).Trim
					Else If strSplit2(0).Contains("level") Then
						strLEVEL = strSplit2(1).Trim
					Else If strSplit2(0).Contains("frequency") Then
						strFREQUENCY = strSplit2(1).Trim
					End If
				End If
			Next
			
			If strSECURITY.Contains("WPA2") Then
				strSECURITY = "WPA2"
			Else If strSECURITY.Contains("WPA") Then
				strSECURITY = "WPA"
			Else If strSECURITY.Contains("WEP") Then
				strSECURITY = "WEP"
			Else
				strSECURITY = "OPEN"
			End If
			
			If strLEVEL >= -30 Then
				sSignal = "Excellent"
			Else If strLEVEL >= -67 Then
				sSignal = "Very Good"
			Else If strLEVEL >= -70 Then
				sSignal = "Good"
			Else If strLEVEL >= -80 Then
				sSignal = "Bad"
			Else
				sSignal = "Very Bad"
			End If
			
			sState = ""
			sRank = 0
			
			For k = 0 To listConfigured.Size -1
				'			Msgbox(listConfigured.Get(k), "")
				Dim strCont As String = listConfigured.Get(k)
				If strCont.Contains(Chr(34) & strSSID & Chr(34)) Then
					sRank = strCont.SubString2(strCont.IndexOf("ID: ")+4, _
												strCont.IndexOf("SSID: "))
					'				Msgbox(sRank, "")
					If IsNumber(sRank) = False Then
						sRank = 0
					End If
				
					If strCont.Contains("DSBLE") Then
						sState = "Saved"
					Else
						sState = "Connected" 'Mémorise la connexion wifi actuelle du smartphone
						
						If  strSSID.Contains("TP-LINK")=False Then 'Identifie le réseau local et exclus le réseau tP
							Network_Local=strSSID
							Ref_Network= strSSID & "," & _
							strSECURITY & "," & _
							strLEVEL & "," & _
							strFREQUENCY & "," & _
							sState & "," & _
							sRank
		'						ResultsBkp.Add(strSSID & "," & _
		'							strSECURITY & "," & _
		'							strLEVEL & "," & _
		'							strFREQUENCY & "," & _
		'							sState & "," & _
		'							sRank)
							Sleep(1000)
						End If
						
						
					End If
				End If
			Next
			'ListView1.TwoLinesLayout.Label.TextSize=15
			If strSSID.Contains("TP-LINK") Then 'Filtrage sur le device
				
				sending_data=False 'autorise l'envoi d'une requête
				 device=strSSID
				Mac_Address= strBSSID
				
'				If sState = "Saved" Then
'					
'					ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Saved, Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'				Else If sState = "Connected" Then
'					ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Connected, Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'				Else
				'
'					ListView1.AddTwoLines2(strSSID & " [" & strBSSID & "]", _
'								"Security: " & strSECURITY & _
'								", Signal: " & sSignal & _
'								" (" & strLEVEL & " dBm)", i)
'				End If

				ResultsBkp.Add(strSSID & "," & _
							strSECURITY & "," & _
							strLEVEL & "," & _
							strFREQUENCY & "," & _
							sState & "," & _
							sRank & "," & _
							strBSSID)
			End If
			
			
			
		Next
	Catch
		Log(LastException)
	End Try
	
	' renvoie de la valeur vers l'IU
	If device<>"Recherche en cours..."  Then
		
		If  TPL_Echange.Answer_Data=False Then
			CallSub2(Main.IU_Setup_Power_connected,"refresh",device)
			'CallSub2(Main,"CallBack_IU",device)
			SSID_name_tplink=device
			Dim Return_connect As Boolean = WiFiConnect1.ConnectToSSID(0,device,"") 'Connexion sur la prise
		
			
			If Return_connect=True Then
				Sleep(5000)
				Ip= WiFiConnect1.getIpAddress
				'Ip_connectfrom_Tplink = TPL_Echange.server.GetMyWifiIP 'Récupère l'adresse ip du serveur
				'Ip= Ip_connectfrom_Tplink
				'Dim array_ip() As Byte=bconv.StringToBytes(ip,"ASCII")
				Dim strSplit_ip() As String = Regex.Split("[.]", Ip)
			
				strSplit_ip(3)=1
				Ip= strSplit_ip(0) & "." & strSplit_ip(1) & "." & strSplit_ip(2) & "." & strSplit_ip(3)
				
				If Ip="0.0.0.1" Then 'si on perd le wifi du device on relance le scan
					Sleep(500)
					scan
				Else
					' Appel Routine envoir requête sur le device
					If Main.IU_Setup_Power_connected <> Null Then
						CallSubDelayed2(Main.iu_Setup_Power_connected,"tryAdd",Ref_Network)
					End If
					
					'CallSubDelayed2(Main,"CallBack_Requete",Ref_Network)
				End If
				
				
			
			Else ' Reconnexion sur le réseau et  Relance scan
			
				wait for (connect_toNetwork) complete (result As Boolean) 'Pas obligatoire
			
				If result = True Then
					Sleep(500) 'Relance le scan
					scan
				Else
					StopService(Me)
				End If
			
			End If
		Else 'contrôle si la prise a basculé sur le réseau local
			
			If  TPL_Echange.Answer_Data=True Then
				device="Prise configurée"
				CallSub2(Main.iu_Setup_Power_connected,"refresh",device)
				'CallSub2(Main,"CallBack_IU",device)
				
			Else
				Sleep(500) 'Relance le scan
				scan
			End If
			
			
		End If
		
	Else
		Sleep(500) 'Relance le scan
		scan
	End If
	
'	If Setup_Power_connected.test_devive=True Then
'		
'	End If
	
End Sub
Sub  state_connexion
	
	If TPL_Echange.connected =True And sending_data=False Then 'Envoi le paramétrage wifi sur le device
		sending_data=True 'limite à un seul envoi
		Wait For (load_data(tplink_entete,Network)) complete (result As Boolean)
	End If
	
End Sub

Sub connect_toNetwork As ResumableSub
	
	Dim strSplit() As String = Regex.Split(",", Ref_Network)
	Dim result As Boolean= WiFiConnect1.enableNetwork(strSplit(5), True)
	
	Return result
	
End Sub

Sub read_info
	
End Sub

Sub Service_Destroy

End Sub
